//Respawn eines Fahrzeuges. Ausfhrung erfolgt beim Server. [Vienna 03.11.2011]
//
//  Respawn wahlweise mit vorhanden gewesenere Besatzung und dann mit oder ohne Fahrt zum Einsatzziel. 
//  
//Das Skript wird in der Initzeile eines Fahrzeuges mit Besatzung gestartet.
//
//Aufruf: [<Fahrzeug>,<Respawnzeit>,<Respawnanzahl>,<Position des Einsatzortes>] execVM "FahrzeugRespawn_KI_WP.sqf";
//
//Beispiel fr Aufruf in der Initzeile des Fahrzeuges (fr den Zielort wird ein Marker Namens "ZielOrt" angenommen):
// temp = [this, 15, 3, markerPos "ZielOrt"] execVM "FahrzeugRespawn_KI_WP.sqf";
//  Ist ein Fahrer im Fahrzeug, dann Fhrt das Fahrzeug zum Einsatzziel.
//  Wird der Zielort weggelassen, dann bleibt das Fahrzeug vor Ort stehen.
//  Ist kein Fahrer im Fahrzeug, dann bleibt es natrlich auch stehen und Respawnt ohne Besatzung.


if (!isServer) exitWith {}; // Programm nicht ausfhren, wenn nicht Server/Host.

//Lokale Variable
Private ["_clearAllWP","_Vehikel","_RespZeit","_ZielPos","_Respawns","_StartPos","_Richtung","_Driver","_Gunner","_Comman","_Gruppe","_i","_temp"];

//Parameter:
 _Vehikel = _this select 0; //Fahrzeug
 _RespZeit = _this select 1; //Respawnzeit
 _Respawns = _this select 2; //Anzahl der Respawns
 _ZielPos = _this select 3; //Position des Einsatzortes

//Position des Respawnortes
 _StartPos = position _Vehikel;
//Ausrichtung des Fahrzeuges 
 _Richtung = getDir _Vehikel;
  
//Besatzung auslesen
 if (! isNull driver _Vehikel) then {_Driver = driver _Vehikel; _Gruppe = group _Driver}; 
 if (! isNull gunner _Vehikel) then {_Gunner = driver _Vehikel; _Gruppe = group _Gunner}; 
 if (! isNull commander _Vehikel) then {_Comman = driver _Vehikel; _Gruppe = group _Comman}; 

//Wenn Besatzung vorhanden, dann Guppe ein Verhalten zuweisen.
 if (! isNil "_Gruppe") then
  {
   //Kampfverhalten der Gruppe: 
   //Verhalten: sorglos/deckungslos --> "CARELESS","SAFE","AWARE","COMBAT","STEALTH" <-- vorsichtig/Ausntzung jeder Deckung 	
   _Gruppe setBehaviour "AWARE";
   //SpeedMode: "LIMITED"(half speed),"NORMAL"(full speed, maintain formation),"FULL"(do not wait for any other units in formation)
   _Gruppe setSpeedMode "NORMAL"; 
   //CombatMode: "BLUE"(Never fire),"GREEN"(Hold fire-defend only),"WHITE"(Hold fire,engage at will),"YELLOW"(Fire at will),"RED"(Fire at will,engage at will),
   _Gruppe setCombatMode "WHITE";
   //Formation: "COLUMN","STAG COLUMN","WEDGE","ECH LEFT","ECH RIGHT","VEE","LINE","FILE","DIAMOND"
   _Gruppe setFormation "LINE";
   //Fluchtverhalten: 0 = 0%, 1 = 100%
   _Gruppe allowFleeing 0.5   
  };

//Schleife fr die Anzahl der Respawns
for "_i" from 0 to _Respawns do
 {
 //Einsatzort bzw. Besatzung vorhanden? Dann Wegpunkt erstellen.
 if (! isNil "_ZielPos" and ! isNil "_Gruppe") then
  {
   //Wegpunkt zum Einsatzort erstellen
   _temp = _Gruppe addWaypoint [_ZielPos,0];
   [_Gruppe, 0] SetWaypointType "MOVE";
   _Gruppe setCurrentWaypoint [_Gruppe, 1]
  };
 if (_i < _Respawns) then
  {
  //Waren mit oder ohne Besatzung
  if (! isNil "_Gruppe") then {waitUntil {count Crew _Vehikel == 0 or damage _Vehikel > 0.8}} //Warten bis Fahrzeug zerstrt oder ohne Besatzung. 
  else {waitUntil {damage _Vehikel > 0.8}}; //nur warten bis Fahrzeug zerstrt.
  //Wegpunkt lschen falls vorhanden
  if (! isNil "_ZielPos" and ! isNil "_Gruppe") then {deleteWaypoint[_Gruppe,1]};
  //neues Fahrzeug nach Ablauf der Respawnzeit erstellen
  sleep _RespZeit;
  _Vehikel = createVehicle [typeOf _Vehikel, _StartPos, [], 0, "FORM"];
  _Vehikel setDir _Richtung;
  //Besatzung erstellen, falls eine beim Spielstart vorhanden
  if (! isNil "_Driver") then
   {
   _Driver = _Gruppe createUnit [typeOf _Driver, [0,0], [], 0, "FORM"];
   _Driver moveInDriver _Vehikel
   }; 
  if (! isNil "_Gunner") then
   {
   _Gunner = _Gruppe createUnit [typeOf _Gunner, [0,0], [], 0, "FORM"];
   _Gunner moveInGunner _Vehikel
   }; 
  if (! isNil "_Comman") then 
   {
   _Comman = _Gruppe createUnit [typeOf _Comman, [0,0], [], 0, "FORM"];
   _Comman moveInCommander _Vehikel
   }
  }
 }
